# GstAdapter

This class is for elements that receive buffers in an undesired size. While for example raw video contains one image per buffer, the same is not true for a lot of other formats, especially those that come directly from a file. So if you have undefined buffer sizes and require a specific size, this object is for you.

An adapter is created with gst_adapter_new. It can be freed again with g_object_unref.

The theory of operation is like this: All buffers received are put into the adapter using gst_adapter_push and the data is then read back in chunks of the desired size using gst_adapter_map/gst_adapter_unmap and/or gst_adapter_copy. After the data has been processed, it is freed using gst_adapter_unmap.

Other methods such as gst_adapter_take and gst_adapter_take_buffer combine gst_adapter_map and gst_adapter_unmap in one method and are potentially more convenient for some use cases.

For example, a sink pad's chain function that needs to pass data to a library in 512-byte chunks could be implemented like this:

     static GstFlowReturn
     sink_pad_chain (GstPad *pad, GstObject *parent, GstBuffer *buffer)
     {
       MyElement *this;
       GstAdapter *adapter;
       GstFlowReturn ret = GST_FLOW_OK;

       this = MY_ELEMENT (parent);

       adapter = this->adapter;

       // put buffer into adapter
       gst_adapter_push (adapter, buffer);

       // while we can read out 512 bytes, process them
       while (gst_adapter_available (adapter) >= 512 && ret == GST_FLOW_OK) {
         const guint8 *data = gst_adapter_map (adapter, 512);
         // use flowreturn as an error value
         ret = my_library_foo (data);
         gst_adapter_unmap (adapter);
         gst_adapter_flush (adapter, 512);
       }
       return ret;
     }

For another example, a simple element inside GStreamer that uses GstAdapter is the libvisual element.

An element using GstAdapter in its sink pad chain function should ensure that when the FLUSH_STOP event is received, that any queued data is cleared using gst_adapter_clear. Data should also be cleared or processed on EOS and when changing state from GST_STATE_PAUSED to GST_STATE_READY.

Also check the GST_BUFFER_FLAG_DISCONT flag on the buffer. Some elements might need to clear the adapter after a discontinuity.

The adapter will keep track of the timestamps of the buffers that were pushed. The last seen timestamp before the current position can be queried with gst_adapter_prev_pts. This function can optionally return the number of bytes between the start of the buffer that carried the timestamp and the current adapter position. The distance is useful when dealing with, for example, raw audio samples because it allows you to calculate the timestamp of the current adapter position by using the last seen timestamp and the amount of bytes since. Additionally, the gst_adapter_prev_pts_at_offset can be used to determine the last seen timestamp at a particular offset in the adapter.

The adapter will also keep track of the offset of the buffers (#GST_BUFFER_OFFSET) that were pushed. The last seen offset before the current position can be queried with gst_adapter_prev_offset. This function can optionally return the number of bytes between the start of the buffer that carried the offset and the current adapter position.

Additionally the adapter also keeps track of the PTS, DTS and buffer offset at the last discontinuity, which can be retrieved with gst_adapter_pts_at_discont, gst_adapter_dts_at_discont and gst_adapter_offset_at_discont. The number of bytes that were consumed since then can be queried with gst_adapter_distance_from_discont.

A last thing to note is that while GstAdapter is pretty optimized, merging buffers still might be an operation that requires a `malloc()` and `memcpy()` operation, and these operations are not the fastest. Because of this, some functions like gst_adapter_available_fast are provided to help speed up such cases should you want to. To avoid repeated memory allocations, gst_adapter_copy can be used to copy data into a (statically allocated) user provided buffer.

GstAdapter is not MT safe. All operations on an adapter must be serialized by the caller. This is not normally a problem, however, as the normal use case of GstAdapter is inside one pad's chain function, in which case access is serialized via the pad's STREAM_LOCK.

Note that gst_adapter_push takes ownership of the buffer passed. Use gst_buffer_ref before pushing it into the adapter if you still want to access the buffer later. The adapter will never modify the data in the buffer pushed in it.

## GstAdapter

    GObject
        ╰──GstAdapter

The opaque GstAdapter data structure.

### Class structure

#### GstAdapterClass

### GstBase.AdapterClass

## GstBase.Adapter

    GObject.Object
        ╰──GstBase.Adapter

The opaque GstBase.Adapter data structure.

## GstBase.Adapter

    GObject.Object
        ╰──GstBase.Adapter

The opaque GstBase.Adapter data structure.

### Constructors

#### gst_adapter_new

    GstAdapter *
    gst_adapter_new ()

Creates a new GstAdapter. Free with g_object_unref.

Returns ( [transfer: full]) –

a new GstAdapter

#### GstBase.Adapter.prototype.new

    function GstBase.Adapter.prototype.new(): {
        // javascript wrapper for 'gst_adapter_new'
    }

Creates a new GstBase.Adapter. Free with GObject.Object.prototype.unref.

Returns (GstBase.Adapter) –

a new GstBase.Adapter

#### GstBase.Adapter.new

    def GstBase.Adapter.new ():
        #python wrapper for 'gst_adapter_new'

Creates a new GstBase.Adapter. Free with GObject.Object.unref.

Returns (GstBase.Adapter) –

a new GstBase.Adapter

### Methods

#### gst_adapter_available

    gsize
    gst_adapter_available (GstAdapter * adapter)

Gets the maximum amount of bytes available, that is it returns the maximum value that can be supplied to gst_adapter_map without that function returning NULL.

Parameters:

`adapter` –

a GstAdapter

Returns –

number of bytes available in adapter

#### GstBase.Adapter.prototype.available

    function GstBase.Adapter.prototype.available(): {
        // javascript wrapper for 'gst_adapter_available'
    }

Gets the maximum amount of bytes available, that is it returns the maximum value that can be supplied to GstBase.Adapter.prototype.map without that function returning NULL.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

number of bytes available in adapter

#### GstBase.Adapter.available

    def GstBase.Adapter.available (self):
        #python wrapper for 'gst_adapter_available'

Gets the maximum amount of bytes available, that is it returns the maximum value that can be supplied to GstBase.Adapter.map without that function returning NULL.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

number of bytes available in adapter

#### gst_adapter_available_fast

    gsize
    gst_adapter_available_fast (GstAdapter * adapter)

Gets the maximum number of bytes that are immediately available without requiring any expensive operations (like copying the data into a temporary buffer).

Parameters:

`adapter` –

a GstAdapter

Returns –

number of bytes that are available in adapter without expensive operations

#### GstBase.Adapter.prototype.available_fast

    function GstBase.Adapter.prototype.available_fast(): {
        // javascript wrapper for 'gst_adapter_available_fast'
    }

Gets the maximum number of bytes that are immediately available without requiring any expensive operations (like copying the data into a temporary buffer).

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

number of bytes that are available in adapter without expensive operations

#### GstBase.Adapter.available_fast

    def GstBase.Adapter.available_fast (self):
        #python wrapper for 'gst_adapter_available_fast'

Gets the maximum number of bytes that are immediately available without requiring any expensive operations (like copying the data into a temporary buffer).

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

number of bytes that are available in adapter without expensive operations

#### gst_adapter_clear

    gst_adapter_clear (GstAdapter * adapter)

Removes all buffers from adapter.

Parameters:

`adapter` –

a GstAdapter

#### GstBase.Adapter.prototype.clear

    function GstBase.Adapter.prototype.clear(): {
        // javascript wrapper for 'gst_adapter_clear'
    }

Removes all buffers from adapter.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

#### GstBase.Adapter.clear

    def GstBase.Adapter.clear (self):
        #python wrapper for 'gst_adapter_clear'

Removes all buffers from adapter.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

#### gst_adapter_copy

    gst_adapter_copy (GstAdapter * adapter,
                      gpointer dest,
                      gsize offset,
                      gsize size)

Copies size bytes of data starting at offset out of the buffers contained in GstAdapter into an array dest provided by the caller.

The array dest should be large enough to contain size bytes. The user should check that the adapter has (@offset + size) bytes available before calling this function.

Parameters:

`adapter` –

a GstAdapter

`dest` –

(out caller-allocates) (array length=size) (element-type guint8): the memory to copy into

`offset` –

the bytes offset in the adapter to start from

`size` ( [in]) –

the number of bytes to copy

#### gst_adapter_copy_bytes

    GBytes *
    gst_adapter_copy_bytes (GstAdapter * adapter,
                            gsize offset,
                            gsize size)

Similar to gst_adapter_copy, but more suitable for language bindings. size bytes of data starting at offset will be copied out of the buffers contained in adapter and into a new GBytes structure which is returned. Depending on the value of the size argument an empty GBytes structure may be returned.

Parameters:

`adapter` –

a GstAdapter

`offset` –

the bytes offset in the adapter to start from

`size` –

the number of bytes to copy

Returns ( [transfer: full]) –

A new GBytes structure containing the copied data.

Since : 1.4

#### GstBase.Adapter.prototype.copy_bytes

    function GstBase.Adapter.prototype.copy_bytes(offset: Number, size: Number): {
        // javascript wrapper for 'gst_adapter_copy_bytes'
    }

Similar to gst_adapter_copy, but more suitable for language bindings. size bytes of data starting at offset will be copied out of the buffers contained in adapter and into a new GBytes (not introspectable) structure which is returned. Depending on the value of the size argument an empty GBytes (not introspectable) structure may be returned.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (Number) –

the bytes offset in the adapter to start from

`size` (Number) –

the number of bytes to copy

Returns (GBytes (not introspectable)) –

A new GBytes (not introspectable) structure containing the copied data.

Since : 1.4

#### GstBase.Adapter.copy_bytes

    def GstBase.Adapter.copy_bytes (self, offset, size):
        #python wrapper for 'gst_adapter_copy_bytes'

Similar to gst_adapter_copy, but more suitable for language bindings. size bytes of data starting at offset will be copied out of the buffers contained in adapter and into a new GBytes (not introspectable) structure which is returned. Depending on the value of the size argument an empty GBytes (not introspectable) structure may be returned.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (int) –

the bytes offset in the adapter to start from

`size` (int) –

the number of bytes to copy

Returns (GBytes (not introspectable)) –

A new GBytes (not introspectable) structure containing the copied data.

Since : 1.4

#### gst_adapter_distance_from_discont

    guint64
    gst_adapter_distance_from_discont (GstAdapter * adapter)

Get the distance in bytes since the last buffer with the GST_BUFFER_FLAG_DISCONT flag.

The distance will be reset to 0 for all buffers with GST_BUFFER_FLAG_DISCONT on them, and then calculated for all other following buffers based on their size.

Parameters:

`adapter` –

a GstAdapter

Returns –

The offset. Can be GST_BUFFER_OFFSET_NONE.

Since : 1.10

#### GstBase.Adapter.prototype.distance_from_discont

    function GstBase.Adapter.prototype.distance_from_discont(): {
        // javascript wrapper for 'gst_adapter_distance_from_discont'
    }

Get the distance in bytes since the last buffer with the Gst.BufferFlags.DISCONT flag.

The distance will be reset to 0 for all buffers with Gst.BufferFlags.DISCONT on them, and then calculated for all other following buffers based on their size.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

The offset. Can be Gst.BUFFER_OFFSET_NONE.

Since : 1.10

#### GstBase.Adapter.distance_from_discont

    def GstBase.Adapter.distance_from_discont (self):
        #python wrapper for 'gst_adapter_distance_from_discont'

Get the distance in bytes since the last buffer with the Gst.BufferFlags.DISCONT flag.

The distance will be reset to 0 for all buffers with Gst.BufferFlags.DISCONT on them, and then calculated for all other following buffers based on their size.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

The offset. Can be Gst.BUFFER_OFFSET_NONE.

Since : 1.10

#### gst_adapter_dts_at_discont

    GstClockTime
    gst_adapter_dts_at_discont (GstAdapter * adapter)

Get the DTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` –

a GstAdapter

Returns –

The DTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### GstBase.Adapter.prototype.dts_at_discont

    function GstBase.Adapter.prototype.dts_at_discont(): {
        // javascript wrapper for 'gst_adapter_dts_at_discont'
    }

Get the DTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

The DTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### GstBase.Adapter.dts_at_discont

    def GstBase.Adapter.dts_at_discont (self):
        #python wrapper for 'gst_adapter_dts_at_discont'

Get the DTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

The DTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### gst_adapter_flush

    gst_adapter_flush (GstAdapter * adapter,
                       gsize flush)

Flushes the first flush bytes in the adapter. The caller must ensure that at least this many bytes are available.

See also: gst_adapter_map, gst_adapter_unmap

Parameters:

`adapter` –

a GstAdapter

`flush` –

the number of bytes to flush

#### GstBase.Adapter.prototype.flush

    function GstBase.Adapter.prototype.flush(flush: Number): {
        // javascript wrapper for 'gst_adapter_flush'
    }

Flushes the first flush bytes in the adapter. The caller must ensure that at least this many bytes are available.

See also: GstBase.Adapter.prototype.map, GstBase.Adapter.prototype.unmap

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`flush` (Number) –

the number of bytes to flush

#### GstBase.Adapter.flush

    def GstBase.Adapter.flush (self, flush):
        #python wrapper for 'gst_adapter_flush'

Flushes the first flush bytes in the adapter. The caller must ensure that at least this many bytes are available.

See also: GstBase.Adapter.map, GstBase.Adapter.unmap

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`flush` (int) –

the number of bytes to flush

#### gst_adapter_get_buffer

    GstBuffer *
    gst_adapter_get_buffer (GstAdapter * adapter,
                            gsize nbytes)

Returns a GstBuffer containing the first nbytes of the adapter, but does not flush them from the adapter. See gst_adapter_take_buffer for details.

Caller owns a reference to the returned buffer. gst_buffer_unref after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to get

Returns ( [transfer: full][nullable]) –

a GstBuffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref when no longer needed.

Since : 1.6

#### GstBase.Adapter.prototype.get_buffer

    function GstBase.Adapter.prototype.get_buffer(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_get_buffer'
    }

Returns a Gst.Buffer containing the first nbytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.prototype.take_buffer for details.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to get

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.6

#### GstBase.Adapter.get_buffer

    def GstBase.Adapter.get_buffer (self, nbytes):
        #python wrapper for 'gst_adapter_get_buffer'

Returns a Gst.Buffer containing the first nbytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.take_buffer for details.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to get

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.6

#### gst_adapter_get_buffer_fast

    GstBuffer *
    gst_adapter_get_buffer_fast (GstAdapter * adapter,
                                 gsize nbytes)

Returns a GstBuffer containing the first nbytes of the adapter, but does not flush them from the adapter. See gst_adapter_take_buffer_fast for details.

Caller owns a reference to the returned buffer. gst_buffer_unref after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to get

Returns ( [transfer: full][nullable]) –

a GstBuffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref when no longer needed.

Since : 1.6

#### GstBase.Adapter.prototype.get_buffer_fast

    function GstBase.Adapter.prototype.get_buffer_fast(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_get_buffer_fast'
    }

Returns a Gst.Buffer containing the first nbytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.prototype.take_buffer_fast for details.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to get

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.6

#### GstBase.Adapter.get_buffer_fast

    def GstBase.Adapter.get_buffer_fast (self, nbytes):
        #python wrapper for 'gst_adapter_get_buffer_fast'

Returns a Gst.Buffer containing the first nbytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.take_buffer_fast for details.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to get

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.6

#### gst_adapter_get_buffer_list

    GstBufferList *
    gst_adapter_get_buffer_list (GstAdapter * adapter,
                                 gsize nbytes)

Returns a GstBufferList of buffers containing the first nbytes bytes of the adapter but does not flush them from the adapter. See gst_adapter_take_buffer_list for details.

Caller owns the returned list. Call gst_buffer_list_unref to free the list after usage.

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to get

Returns ( [transfer: full][nullable]) –

a GstBufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.prototype.get_buffer_list

    function GstBase.Adapter.prototype.get_buffer_list(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_get_buffer_list'
    }

Returns a Gst.BufferList of buffers containing the first nbytes bytes of the adapter but does not flush them from the adapter. See GstBase.Adapter.prototype.take_buffer_list for details.

Caller owns the returned list. Call gst_buffer_list_unref (not introspectable) to free the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to get

Returns (Gst.BufferList) –

a Gst.BufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.get_buffer_list

    def GstBase.Adapter.get_buffer_list (self, nbytes):
        #python wrapper for 'gst_adapter_get_buffer_list'

Returns a Gst.BufferList of buffers containing the first nbytes bytes of the adapter but does not flush them from the adapter. See GstBase.Adapter.take_buffer_list for details.

Caller owns the returned list. Call gst_buffer_list_unref (not introspectable) to free the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to get

Returns (Gst.BufferList) –

a Gst.BufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### gst_adapter_get_list

    GList *
    gst_adapter_get_list (GstAdapter * adapter,
                          gsize nbytes)

Returns a GList of buffers containing the first nbytes bytes of the adapter, but does not flush them from the adapter. See gst_adapter_take_list for details.

Caller owns returned list and contained buffers. gst_buffer_unref each buffer in the list before freeing the list after usage.

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to get

Returns ( [element-typeGst.Buffer][transfer: full][nullable]) –

a GList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.prototype.get_list

    function GstBase.Adapter.prototype.get_list(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_get_list'
    }

Returns a GLib.List of buffers containing the first nbytes bytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.prototype.take_list for details.

Caller owns returned list and contained buffers. gst_buffer_unref (not introspectable) each buffer in the list before freeing the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to get

Returns ([ Gst.Buffer ]) –

a GLib.List of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.get_list

    def GstBase.Adapter.get_list (self, nbytes):
        #python wrapper for 'gst_adapter_get_list'

Returns a GLib.List of buffers containing the first nbytes bytes of the adapter, but does not flush them from the adapter. See GstBase.Adapter.take_list for details.

Caller owns returned list and contained buffers. gst_buffer_unref (not introspectable) each buffer in the list before freeing the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to get

Returns ([ Gst.Buffer ]) –

a GLib.List of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### gst_adapter_map

    gconstpointer
    gst_adapter_map (GstAdapter * adapter,
                     gsize size)

Gets the first size bytes stored in the adapter. The returned pointer is valid until the next function is called on the adapter.

Note that setting the returned pointer as the data of a GstBuffer is incorrect for general-purpose plugins. The reason is that if a downstream element stores the buffer so that it has access to it outside of the bounds of its chain function, the buffer will have an invalid data pointer after your element flushes the bytes. In that case you should use gst_adapter_take, which returns a freshly-allocated buffer that you can set as GstBuffer memory or the potentially more performant gst_adapter_take_buffer.

Returns NULL if size bytes are not available.

Parameters:

`adapter` –

a GstAdapter

`size` –

the number of bytes to map/peek

Returns –

(transfer none) (array length=size) (element-type guint8) (nullable): a pointer to the first size bytes of data, or NULL

#### GstBase.Adapter.prototype.map

    function GstBase.Adapter.prototype.map(): {
        // javascript wrapper for 'gst_adapter_map'
    }

Gets the first size bytes stored in the adapter. The returned pointer is valid until the next function is called on the adapter.

Note that setting the returned pointer as the data of a Gst.Buffer is incorrect for general-purpose plugins. The reason is that if a downstream element stores the buffer so that it has access to it outside of the bounds of its chain function, the buffer will have an invalid data pointer after your element flushes the bytes. In that case you should use GstBase.Adapter.prototype.take, which returns a freshly-allocated buffer that you can set as Gst.Buffer memory or the potentially more performant GstBase.Adapter.prototype.take_buffer.

Returns NULL if size bytes are not available.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

([ Number ] ) –

(transfer none) (array length=size) (element-type guint8) (nullable): a pointer to the first size bytes of data, or NULL

`size` (Number ) –

(transfer none) (array length=size) (element-type guint8) (nullable): a pointer to the first size bytes of data, or NULL

#### GstBase.Adapter.map

    def GstBase.Adapter.map (self):
        #python wrapper for 'gst_adapter_map'

Gets the first size bytes stored in the adapter. The returned pointer is valid until the next function is called on the adapter.

Note that setting the returned pointer as the data of a Gst.Buffer is incorrect for general-purpose plugins. The reason is that if a downstream element stores the buffer so that it has access to it outside of the bounds of its chain function, the buffer will have an invalid data pointer after your element flushes the bytes. In that case you should use GstBase.Adapter.take, which returns a freshly-allocated buffer that you can set as Gst.Buffer memory or the potentially more performant GstBase.Adapter.take_buffer.

Returns NULL if size bytes are not available.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

([ int ] ) –

(transfer none) (array length=size) (element-type guint8) (nullable): a pointer to the first size bytes of data, or NULL

`size` (int ) –

(transfer none) (array length=size) (element-type guint8) (nullable): a pointer to the first size bytes of data, or NULL

#### gst_adapter_masked_scan_uint32

    gssize
    gst_adapter_masked_scan_uint32 (GstAdapter * adapter,
                                    guint32 mask,
                                    guint32 pattern,
                                    gsize offset,
                                    gsize size)

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

This function calls gst_adapter_masked_scan_uint32_peek passing NULL for value.

Parameters:

`adapter` –

a GstAdapter

`mask` –

mask to apply to data before matching against pattern

`pattern` –

pattern to match (after mask is applied)

`offset` –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` –

number of bytes to scan from offset

Returns –

offset of the first match, or -1 if no match was found.

Example:

     // Assume the adapter contains 0x00 0x01 0x02 ... 0xfe 0xff

     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 1, 255);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x01020304, 1, 255);
     // -> returns 1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0001, 0, 256);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 256);
     // -> returns 2
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 4);
     // -> returns -1

#### GstBase.Adapter.prototype.masked_scan_uint32

    function GstBase.Adapter.prototype.masked_scan_uint32(mask: Number, pattern: Number, offset: Number, size: Number): {
        // javascript wrapper for 'gst_adapter_masked_scan_uint32'
    }

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

This function calls GstBase.Adapter.prototype.masked_scan_uint32_peek passing NULL for value.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`mask` (Number) –

mask to apply to data before matching against pattern

`pattern` (Number) –

pattern to match (after mask is applied)

`offset` (Number) –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` (Number) –

number of bytes to scan from offset

Returns (Number) –

offset of the first match, or -1 if no match was found.

Example:

     // Assume the adapter contains 0x00 0x01 0x02 ... 0xfe 0xff

     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 1, 255);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x01020304, 1, 255);
     // -> returns 1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0001, 0, 256);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 256);
     // -> returns 2
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 4);
     // -> returns -1

#### GstBase.Adapter.masked_scan_uint32

    def GstBase.Adapter.masked_scan_uint32 (self, mask, pattern, offset, size):
        #python wrapper for 'gst_adapter_masked_scan_uint32'

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

This function calls GstBase.Adapter.masked_scan_uint32_peek passing NULL for value.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`mask` (int) –

mask to apply to data before matching against pattern

`pattern` (int) –

pattern to match (after mask is applied)

`offset` (int) –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` (int) –

number of bytes to scan from offset

Returns (int) –

offset of the first match, or -1 if no match was found.

Example:

     // Assume the adapter contains 0x00 0x01 0x02 ... 0xfe 0xff

     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x00010203, 1, 255);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffffffff, 0x01020304, 1, 255);
     // -> returns 1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0001, 0, 256);
     // -> returns -1
     gst_adapter_masked_scan_uint32 (adapter, 0xffff, 0x0203, 0, 256);
     // -> returns 0
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 256);
     // -> returns 2
     gst_adapter_masked_scan_uint32 (adapter, 0xffff0000, 0x02030000, 0, 4);
     // -> returns -1

#### gst_adapter_masked_scan_uint32_peek

    gssize
    gst_adapter_masked_scan_uint32_peek (GstAdapter * adapter,
                                         guint32 mask,
                                         guint32 pattern,
                                         gsize offset,
                                         gsize size,
                                         guint32* value)

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset. If a match is found, the value that matched is returned through value, otherwise value is left untouched.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

Parameters:

`adapter` –

a GstAdapter

`mask` –

mask to apply to data before matching against pattern

`pattern` –

pattern to match (after mask is applied)

`offset` –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` –

number of bytes to scan from offset

`value` ( [out][allow-none]) –

pointer to uint32 to return matching data

Returns –

offset of the first match, or -1 if no match was found.

#### GstBase.Adapter.prototype.masked_scan_uint32_peek

    function GstBase.Adapter.prototype.masked_scan_uint32_peek(mask: Number, pattern: Number, offset: Number, size: Number): {
        // javascript wrapper for 'gst_adapter_masked_scan_uint32_peek'
    }

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset. If a match is found, the value that matched is returned through value, otherwise value is left untouched.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`mask` (Number) –

mask to apply to data before matching against pattern

`pattern` (Number) –

pattern to match (after mask is applied)

`offset` (Number) –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` (Number) –

number of bytes to scan from offset

Returns a tuple made of:

(Number ) –

offset of the first match, or -1 if no match was found.

`value` (Number ) –

offset of the first match, or -1 if no match was found.

#### GstBase.Adapter.masked_scan_uint32_peek

    def GstBase.Adapter.masked_scan_uint32_peek (self, mask, pattern, offset, size):
        #python wrapper for 'gst_adapter_masked_scan_uint32_peek'

Scan for pattern pattern with applied mask mask in the adapter data, starting from offset offset. If a match is found, the value that matched is returned through value, otherwise value is left untouched.

The bytes in pattern and mask are interpreted left-to-right, regardless of endianness. All four bytes of the pattern must be present in the adapter for it to match, even if the first or last bytes are masked out.

It is an error to call this function without making sure that there is enough data (offset+size bytes) in the adapter.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`mask` (int) –

mask to apply to data before matching against pattern

`pattern` (int) –

pattern to match (after mask is applied)

`offset` (int) –

offset into the adapter data from which to start scanning, returns the last scanned position.

`size` (int) –

number of bytes to scan from offset

Returns a tuple made of:

(int ) –

offset of the first match, or -1 if no match was found.

`value` (int ) –

offset of the first match, or -1 if no match was found.

#### gst_adapter_offset_at_discont

    guint64
    gst_adapter_offset_at_discont (GstAdapter * adapter)

Get the offset that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_BUFFER_OFFSET_NONE.

Parameters:

`adapter` –

a GstAdapter

Returns –

The offset at the last discont or GST_BUFFER_OFFSET_NONE.

Since : 1.10

#### GstBase.Adapter.prototype.offset_at_discont

    function GstBase.Adapter.prototype.offset_at_discont(): {
        // javascript wrapper for 'gst_adapter_offset_at_discont'
    }

Get the offset that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_BUFFER_OFFSET_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

The offset at the last discont or GST_BUFFER_OFFSET_NONE.

Since : 1.10

#### GstBase.Adapter.offset_at_discont

    def GstBase.Adapter.offset_at_discont (self):
        #python wrapper for 'gst_adapter_offset_at_discont'

Get the offset that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_BUFFER_OFFSET_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

The offset at the last discont or GST_BUFFER_OFFSET_NONE.

Since : 1.10

#### gst_adapter_prev_dts

    GstClockTime
    gst_adapter_prev_dts (GstAdapter * adapter,
                          guint64* distance)

Get the dts that was before the current byte in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` –

a GstAdapter

`distance` ( [out][allow-none]) –

pointer to location for distance, or NULL

Returns –

The previously seen dts.

#### GstBase.Adapter.prototype.prev_dts

    function GstBase.Adapter.prototype.prev_dts(): {
        // javascript wrapper for 'gst_adapter_prev_dts'
    }

Get the dts that was before the current byte in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(Number ) –

The previously seen dts.

`distance` (Number ) –

The previously seen dts.

#### GstBase.Adapter.prev_dts

    def GstBase.Adapter.prev_dts (self):
        #python wrapper for 'gst_adapter_prev_dts'

Get the dts that was before the current byte in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(int ) –

The previously seen dts.

`distance` (int ) –

The previously seen dts.

#### gst_adapter_prev_dts_at_offset

    GstClockTime
    gst_adapter_prev_dts_at_offset (GstAdapter * adapter,
                                    gsize offset,
                                    guint64* distance)

Get the dts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` –

a GstAdapter

`offset` –

the offset in the adapter at which to get timestamp

`distance` ( [out][allow-none]) –

pointer to location for distance, or NULL

Returns –

The previously seen dts at given offset.

Since : 1.2

#### GstBase.Adapter.prototype.prev_dts_at_offset

    function GstBase.Adapter.prototype.prev_dts_at_offset(offset: Number): {
        // javascript wrapper for 'gst_adapter_prev_dts_at_offset'
    }

Get the dts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (Number) –

the offset in the adapter at which to get timestamp

Returns a tuple made of:

(Number ) –

The previously seen dts at given offset.

`distance` (Number ) –

The previously seen dts at given offset.

Since : 1.2

#### GstBase.Adapter.prev_dts_at_offset

    def GstBase.Adapter.prev_dts_at_offset (self, offset):
        #python wrapper for 'gst_adapter_prev_dts_at_offset'

Get the dts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the dts and the current position is returned.

The dts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a dts is removed from the adapter, the dts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (int) –

the offset in the adapter at which to get timestamp

Returns a tuple made of:

(int ) –

The previously seen dts at given offset.

`distance` (int ) –

The previously seen dts at given offset.

Since : 1.2

#### gst_adapter_prev_offset

    guint64
    gst_adapter_prev_offset (GstAdapter * adapter,
                             guint64* distance)

Get the offset that was before the current byte in the adapter. When distance is given, the amount of bytes between the offset and the current position is returned.

The offset is reset to GST_BUFFER_OFFSET_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with an offset is removed from the adapter, the offset and distance returned are GST_BUFFER_OFFSET_NONE and 0 respectively.

Parameters:

`adapter` –

a GstAdapter

`distance` ( [out][allow-none]) –

pointer to a location for distance, or NULL

Returns –

The previous seen offset.

Since : 1.10

#### GstBase.Adapter.prototype.prev_offset

    function GstBase.Adapter.prototype.prev_offset(): {
        // javascript wrapper for 'gst_adapter_prev_offset'
    }

Get the offset that was before the current byte in the adapter. When distance is given, the amount of bytes between the offset and the current position is returned.

The offset is reset to GST_BUFFER_OFFSET_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with an offset is removed from the adapter, the offset and distance returned are GST_BUFFER_OFFSET_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(Number ) –

The previous seen offset.

`distance` (Number ) –

The previous seen offset.

Since : 1.10

#### GstBase.Adapter.prev_offset

    def GstBase.Adapter.prev_offset (self):
        #python wrapper for 'gst_adapter_prev_offset'

Get the offset that was before the current byte in the adapter. When distance is given, the amount of bytes between the offset and the current position is returned.

The offset is reset to GST_BUFFER_OFFSET_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with an offset is removed from the adapter, the offset and distance returned are GST_BUFFER_OFFSET_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(int ) –

The previous seen offset.

`distance` (int ) –

The previous seen offset.

Since : 1.10

#### gst_adapter_prev_pts

    GstClockTime
    gst_adapter_prev_pts (GstAdapter * adapter,
                          guint64* distance)

Get the pts that was before the current byte in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` –

a GstAdapter

`distance` ( [out][allow-none]) –

pointer to location for distance, or NULL

Returns –

The previously seen pts.

#### GstBase.Adapter.prototype.prev_pts

    function GstBase.Adapter.prototype.prev_pts(): {
        // javascript wrapper for 'gst_adapter_prev_pts'
    }

Get the pts that was before the current byte in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(Number ) –

The previously seen pts.

`distance` (Number ) –

The previously seen pts.

#### GstBase.Adapter.prev_pts

    def GstBase.Adapter.prev_pts (self):
        #python wrapper for 'gst_adapter_prev_pts'

Get the pts that was before the current byte in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

(int ) –

The previously seen pts.

`distance` (int ) –

The previously seen pts.

#### gst_adapter_prev_pts_at_offset

    GstClockTime
    gst_adapter_prev_pts_at_offset (GstAdapter * adapter,
                                    gsize offset,
                                    guint64* distance)

Get the pts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` –

a GstAdapter

`offset` –

the offset in the adapter at which to get timestamp

`distance` ( [out][allow-none]) –

pointer to location for distance, or NULL

Returns –

The previously seen pts at given offset.

Since : 1.2

#### GstBase.Adapter.prototype.prev_pts_at_offset

    function GstBase.Adapter.prototype.prev_pts_at_offset(offset: Number): {
        // javascript wrapper for 'gst_adapter_prev_pts_at_offset'
    }

Get the pts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (Number) –

the offset in the adapter at which to get timestamp

Returns a tuple made of:

(Number ) –

The previously seen pts at given offset.

`distance` (Number ) –

The previously seen pts at given offset.

Since : 1.2

#### GstBase.Adapter.prev_pts_at_offset

    def GstBase.Adapter.prev_pts_at_offset (self, offset):
        #python wrapper for 'gst_adapter_prev_pts_at_offset'

Get the pts that was before the byte at offset offset in the adapter. When distance is given, the amount of bytes between the pts and the current position is returned.

The pts is reset to GST_CLOCK_TIME_NONE and the distance is set to 0 when the adapter is first created or when it is cleared. This also means that before the first byte with a pts is removed from the adapter, the pts and distance returned are GST_CLOCK_TIME_NONE and 0 respectively.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`offset` (int) –

the offset in the adapter at which to get timestamp

Returns a tuple made of:

(int ) –

The previously seen pts at given offset.

`distance` (int ) –

The previously seen pts at given offset.

Since : 1.2

#### gst_adapter_pts_at_discont

    GstClockTime
    gst_adapter_pts_at_discont (GstAdapter * adapter)

Get the PTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` –

a GstAdapter

Returns –

The PTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### GstBase.Adapter.prototype.pts_at_discont

    function GstBase.Adapter.prototype.pts_at_discont(): {
        // javascript wrapper for 'gst_adapter_pts_at_discont'
    }

Get the PTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (Number) –

The PTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### GstBase.Adapter.pts_at_discont

    def GstBase.Adapter.pts_at_discont (self):
        #python wrapper for 'gst_adapter_pts_at_discont'

Get the PTS that was on the last buffer with the GST_BUFFER_FLAG_DISCONT flag, or GST_CLOCK_TIME_NONE.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns (int) –

The PTS at the last discont or GST_CLOCK_TIME_NONE.

Since : 1.10

#### gst_adapter_push

    gst_adapter_push (GstAdapter * adapter,
                      GstBuffer * buf)

Adds the data from buf to the data stored inside adapter and takes ownership of the buffer.

Parameters:

`adapter` –

a GstAdapter

`buf` ( [transfer: full]) –

a GstBuffer to add to queue in the adapter

#### GstBase.Adapter.prototype.push

    function GstBase.Adapter.prototype.push(buf: Gst.Buffer): {
        // javascript wrapper for 'gst_adapter_push'
    }

Adds the data from buf to the data stored inside adapter and takes ownership of the buffer.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`buf` (Gst.Buffer) –

a Gst.Buffer to add to queue in the adapter

#### GstBase.Adapter.push

    def GstBase.Adapter.push (self, buf):
        #python wrapper for 'gst_adapter_push'

Adds the data from buf to the data stored inside adapter and takes ownership of the buffer.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`buf` (Gst.Buffer) –

a Gst.Buffer to add to queue in the adapter

#### gst_adapter_take

    gpointer
    gst_adapter_take (GstAdapter * adapter,
                      gsize nbytes)

Returns a freshly allocated buffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter.

Caller owns returned value. g_free after usage.

Free-function: g_free

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to take

Returns –

(transfer full) (array length=nbytes) (element-type guint8) (nullable): oven-fresh hot data, or NULL if nbytes bytes are not available

#### GstBase.Adapter.prototype.take

    function GstBase.Adapter.prototype.take(): {
        // javascript wrapper for 'gst_adapter_take'
    }

Returns a freshly allocated buffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter.

Caller owns returned value. g_free after usage.

Free-function: g_free

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

([ Number ] ) –

(transfer full) (array length=nbytes) (element-type guint8) (nullable): oven-fresh hot data, or NULL if nbytes bytes are not available

`nbytes` (Number ) –

(transfer full) (array length=nbytes) (element-type guint8) (nullable): oven-fresh hot data, or NULL if nbytes bytes are not available

#### GstBase.Adapter.take

    def GstBase.Adapter.take (self):
        #python wrapper for 'gst_adapter_take'

Returns a freshly allocated buffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter.

Caller owns returned value. g_free after usage.

Free-function: g_free

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

Returns a tuple made of:

([ int ] ) –

(transfer full) (array length=nbytes) (element-type guint8) (nullable): oven-fresh hot data, or NULL if nbytes bytes are not available

`nbytes` (int ) –

(transfer full) (array length=nbytes) (element-type guint8) (nullable): oven-fresh hot data, or NULL if nbytes bytes are not available

#### gst_adapter_take_buffer

    GstBuffer *
    gst_adapter_take_buffer (GstAdapter * adapter,
                             gsize nbytes)

Returns a GstBuffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than gst_adapter_take since it can reuse the memory in pushed buffers by subbuffering or merging. This function will always return a buffer with a single memory region.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

Since 1.6 this will also copy over all GstMeta of the input buffers except for meta with the GST_META_FLAG_POOLED flag or with the "memory" tag.

Caller owns a reference to the returned buffer. gst_buffer_unref after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to take

Returns ( [transfer: full][nullable]) –

a GstBuffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref when no longer needed.

#### GstBase.Adapter.prototype.take_buffer

    function GstBase.Adapter.prototype.take_buffer(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_take_buffer'
    }

Returns a Gst.Buffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than GstBase.Adapter.prototype.take since it can reuse the memory in pushed buffers by subbuffering or merging. This function will always return a buffer with a single memory region.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

Since 1.6 this will also copy over all GstMeta of the input buffers except for meta with the Gst.MetaFlags.POOLED flag or with the "memory" tag.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to take

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

#### GstBase.Adapter.take_buffer

    def GstBase.Adapter.take_buffer (self, nbytes):
        #python wrapper for 'gst_adapter_take_buffer'

Returns a Gst.Buffer containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than GstBase.Adapter.take since it can reuse the memory in pushed buffers by subbuffering or merging. This function will always return a buffer with a single memory region.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

Since 1.6 this will also copy over all GstMeta of the input buffers except for meta with the Gst.MetaFlags.POOLED flag or with the "memory" tag.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to take

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

#### gst_adapter_take_buffer_fast

    GstBuffer *
    gst_adapter_take_buffer_fast (GstAdapter * adapter,
                                  gsize nbytes)

Returns a GstBuffer containing the first nbytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than gst_adapter_take_buffer since it can reuse the memory in pushed buffers by subbuffering or merging. Unlike gst_adapter_take_buffer, the returned buffer may be composed of multiple non-contiguous GstMemory objects, no copies are made.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

This will also copy over all GstMeta of the input buffers except for meta with the GST_META_FLAG_POOLED flag or with the "memory" tag.

This function can return buffer up to the return value of gst_adapter_available without making copies if possible.

Caller owns a reference to the returned buffer. gst_buffer_unref after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to take

Returns ( [transfer: full][nullable]) –

a GstBuffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref when no longer needed.

Since : 1.2

#### GstBase.Adapter.prototype.take_buffer_fast

    function GstBase.Adapter.prototype.take_buffer_fast(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_take_buffer_fast'
    }

Returns a Gst.Buffer containing the first nbytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than GstBase.Adapter.prototype.take_buffer since it can reuse the memory in pushed buffers by subbuffering or merging. Unlike GstBase.Adapter.prototype.take_buffer, the returned buffer may be composed of multiple non-contiguous Gst.Memory objects, no copies are made.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

This will also copy over all GstMeta of the input buffers except for meta with the Gst.MetaFlags.POOLED flag or with the "memory" tag.

This function can return buffer up to the return value of GstBase.Adapter.prototype.available without making copies if possible.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to take

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.2

#### GstBase.Adapter.take_buffer_fast

    def GstBase.Adapter.take_buffer_fast (self, nbytes):
        #python wrapper for 'gst_adapter_take_buffer_fast'

Returns a Gst.Buffer containing the first nbytes of the adapter. The returned bytes will be flushed from the adapter. This function is potentially more performant than GstBase.Adapter.take_buffer since it can reuse the memory in pushed buffers by subbuffering or merging. Unlike GstBase.Adapter.take_buffer, the returned buffer may be composed of multiple non-contiguous Gst.Memory objects, no copies are made.

Note that no assumptions should be made as to whether certain buffer flags such as the DISCONT flag are set on the returned buffer, or not. The caller needs to explicitly set or unset flags that should be set or unset.

This will also copy over all GstMeta of the input buffers except for meta with the Gst.MetaFlags.POOLED flag or with the "memory" tag.

This function can return buffer up to the return value of GstBase.Adapter.available without making copies if possible.

Caller owns a reference to the returned buffer. gst_buffer_unref (not introspectable) after usage.

Free-function: gst_buffer_unref

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to take

Returns (Gst.Buffer) –

a Gst.Buffer containing the first nbytes of the adapter, or NULL if nbytes bytes are not available. gst_buffer_unref (not introspectable) when no longer needed.

Since : 1.2

#### gst_adapter_take_buffer_list

    GstBufferList *
    gst_adapter_take_buffer_list (GstAdapter * adapter,
                                  gsize nbytes)

Returns a GstBufferList of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns the returned list. Call gst_buffer_list_unref to free the list after usage.

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to take

Returns ( [transfer: full][nullable]) –

a GstBufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.prototype.take_buffer_list

    function GstBase.Adapter.prototype.take_buffer_list(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_take_buffer_list'
    }

Returns a Gst.BufferList of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns the returned list. Call gst_buffer_list_unref (not introspectable) to free the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to take

Returns (Gst.BufferList) –

a Gst.BufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### GstBase.Adapter.take_buffer_list

    def GstBase.Adapter.take_buffer_list (self, nbytes):
        #python wrapper for 'gst_adapter_take_buffer_list'

Returns a Gst.BufferList of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns the returned list. Call gst_buffer_list_unref (not introspectable) to free the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to take

Returns (Gst.BufferList) –

a Gst.BufferList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

Since : 1.6

#### gst_adapter_take_list

    GList *
    gst_adapter_take_list (GstAdapter * adapter,
                           gsize nbytes)

Returns a GList of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns returned list and contained buffers. gst_buffer_unref each buffer in the list before freeing the list after usage.

Parameters:

`adapter` –

a GstAdapter

`nbytes` –

the number of bytes to take

Returns ( [element-typeGst.Buffer][transfer: full][nullable]) –

a GList of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

#### GstBase.Adapter.prototype.take_list

    function GstBase.Adapter.prototype.take_list(nbytes: Number): {
        // javascript wrapper for 'gst_adapter_take_list'
    }

Returns a GLib.List of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns returned list and contained buffers. gst_buffer_unref (not introspectable) each buffer in the list before freeing the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (Number) –

the number of bytes to take

Returns ([ Gst.Buffer ]) –

a GLib.List of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

#### GstBase.Adapter.take_list

    def GstBase.Adapter.take_list (self, nbytes):
        #python wrapper for 'gst_adapter_take_list'

Returns a GLib.List of buffers containing the first nbytes bytes of the adapter. The returned bytes will be flushed from the adapter. When the caller can deal with individual buffers, this function is more performant because no memory should be copied.

Caller owns returned list and contained buffers. gst_buffer_unref (not introspectable) each buffer in the list before freeing the list after usage.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

`nbytes` (int) –

the number of bytes to take

Returns ([ Gst.Buffer ]) –

a GLib.List of buffers containing the first nbytes of the adapter, or NULL if nbytes bytes are not available

#### gst_adapter_unmap

    gst_adapter_unmap (GstAdapter * adapter)

Releases the memory obtained with the last gst_adapter_map.

Parameters:

`adapter` –

a GstAdapter

#### GstBase.Adapter.prototype.unmap

    function GstBase.Adapter.prototype.unmap(): {
        // javascript wrapper for 'gst_adapter_unmap'
    }

Releases the memory obtained with the last GstBase.Adapter.prototype.map.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

#### GstBase.Adapter.unmap

    def GstBase.Adapter.unmap (self):
        #python wrapper for 'gst_adapter_unmap'

Releases the memory obtained with the last GstBase.Adapter.map.

Parameters:

`adapter` (GstBase.Adapter) –

a GstBase.Adapter

## Constants

### GST_TYPE_ADAPTER

    #define GST_TYPE_ADAPTER \
      (gst_adapter_get_type())

The results of the search are